#ifndef _FLASH_CONTROL_H_
#define _FLASH_CONTROL_H_
    
    extern void Write9A(Uint8 cmd);
    extern void Write9B(Uint8 cmd);
    extern void Write9C(Uint8 cmd);
    extern void Write9D(Uint8 cmd);

    #define FNOP                        0x00
    #define WRITE_BYTE                  0x01
    #define SECTOR_ERASE_WITH_PRE       0x02
    #define CHIP_ERASE_WITH_PRE         0x04
    #define WRITE_BYTE_SHORT            0x08
    #define SECTOR_ERASE_WITHOUT_PRE    0x10
    #define CHIP_ERASE_WITHOUT_PRE      0x18
    #define PROGRAM_CHIP_CALIBRATION    0xA0
    #define PROGRAM_SECTOR_CALIBRATION  0xA8    

    // Program time = (SFR_9C+1)*4+8
    #define PROG_28US       4
    #define PROG_32US       5
    #define PROG_60US       12
    #define PROG_100US      22
    #define PROG_108US      24
    #define PROG_120US      27
    #define PROG_124US      28
    #define PROG_128US      29
    #define PROG_152US      35
    #define PROG_168US      39
    #define PROG_200US      47

    // Erase time = (SFR_9D+1)*16
    #define ERASE_4000US    249
    #define ERASE_3008US    187
    #define ERASE_2000US    124
    #define ERASE_1504US    93
    #define ERASE_1200US    74
    #define ERASE_1008US    62
    #define ERASE_816US     50
    #define ERASE_496US     30    


#endif