#define _DEMO_C_

#include "..\include\include.h"

/****************************************
*Search device                          *
****************************************/
void Search_Device(void)
{
#ifdef Master
    Uint8 i,tmp;
    Uint8 code *readPtr;
    Uint16 j;

    if(~KEY_Pair)
    {
        P1_2 = 0;
        P1 &= 0x07;
        Search_Flag = 0;
        STOP_Flag = 0;
        readPtr = (Uint8*)IAP_ADDRESS;
        tmp = *readPtr;

        if(tmp==0xFF)
        {
            ReadFlash(IAP_ADDRESS,Check_ID,6);
            A8101_WriteReg(ID_REG+4,Check_ID[2]);
            A8101_WriteReg(ID_REG+5,Check_ID[3]);
            A8101_WriteReg(ID_REG+6,Check_ID[4]);
            A8101_WriteReg(ID_REG+7,Check_ID[5]);
        }
        else
            A8101_WriteID();

        if(LINK_FAIL)
        {
            A8101_WriteReg(CODE1_REG,0x1C);
            A8101_WriteReg(CODE2_REG,0x8E);
            A8101_WriteReg(FIFO1_REG,0x01); //FIFO length = 2 bytes
            A8101_WriteReg(FIFO2_REG,0x00);
            A8101_WriteReg(FCR_REG,0x09);   //resend enable, times = 2  (ALL: 1+2=3)
            A8101_WriteReg(CKO_REG,0x72);
            A8101_WriteReg(GIO1_REG,0x00);
            A8101_WriteReg(GIO2_REG,0x10);

            for(j=0;j<500;j++)
            {
                for(i=0;i<3;i++)
                {
                    SetCH(Pair_Tab[i]);
                    A8101_WriteReg(TXDATA_REG     ,~0x81);
                    A8101_WriteReg(TXDATA_REG + 1 ,~0x01);
                    StrobeCmd(CMD_TX);
                    while((A8101_ReadReg(STROBE_REG)&0x80)==0x80);
                    if((A8101_ReadReg(STROBE_REG)&0x08)==0x08)
                    {
                        Search_Flag = 1;
                        break;
                    }
                }

                if(Search_Flag||KEY_Pair)
                {
                    StrobeCmd(CMD_STBY);
                    break;
                }
            }
            LINK_FAIL = 0;
        }

        if((~Search_Flag)&&(~KEY_Pair))
        {
            A8101_WriteReg(CODE1_REG,0x1C);
            A8101_WriteReg(CODE2_REG,0x8E);
            A8101_WriteReg(RCOSC1_REG,0x1F);
            A8101_WriteReg(RCOSC2_REG,0x00);
            A8101_WriteReg(FIFO1_REG,0x01); //FIFO length = 2 bytes
            A8101_WriteReg(FIFO2_REG,0x00);
            A8101_WriteReg(FCR_REG,0x09);   //resend enable, times = 2  (ALL: 1+2=3)
            A8101_WriteReg(CKO_REG,0x72);
            A8101_WriteReg(GIO1_REG,0x00);
            A8101_WriteReg(GIO2_REG,0x10);
            MeasureExtADC();

#ifdef VOXON

            A8101_WriteReg(RCOSC3_REG,0x17);
            StrobeCmd(CMD_SLEEP);
            EIE |= 0x08;
            PCON = 0x02;

            while(1)
            {                
                if(TX_Active)
                {
                    EIE &= 0xF7;    //disable RFINT

                    for(j=0;j<300;j++)
                    {
                        TX_Active = 0;
                        for(i=0;i<3;i++)
                        {
                            SetCH(Pair_Tab[i]);
                            A8101_WriteReg(TXDATA_REG     ,~0x81);
                            A8101_WriteReg(TXDATA_REG + 1 ,~0x01);
                            StrobeCmd(CMD_TX);
                            while((A8101_ReadReg(STROBE_REG)&0x80)==0x80);
                            if((A8101_ReadReg(STROBE_REG)&0x08)==0x08)
                            {
                                Search_Flag = 1;
                                break;
                            }
                        }

                        if(Search_Flag||KEY_Pair)
                        {
                            StrobeCmd(CMD_STBY);
                            break;
                        }
                    }
                    STOP_Flag = 1;
                }

                if(~Search_Flag)
                {
                    for(i=0;i<6;i++)
                    {
                        SetCH(Pair_Tab[Pair_index]);
                        Pair_index++;
                        if(Pair_index>2)
                            Pair_index = 0;

                        StrobeCmd(CMD_RX);
                        TIMEBASE = 5000;
                        InitTimer0();
                        IP |= 0x02;
                        while((~Timer_Flag)&&((A8101_ReadReg(STROBE_REG)&0x80)==0x80));
                        IP &= 0xFD;
                        TR0 = 0;
                        if((A8101_ReadReg(STROBE_REG)&0x80)==0x80)
                            StrobeCmd(CMD_STBY);
                        else
                        {
                            Search_Flag = 1;
                            break;
                        }

                        if(KEY_Pair)
                            break;
                    }
                }
                A8101_WriteReg(RCOSC3_REG,0x17);
								
								if(STOP_Flag)
                {
                    StrobeCmd(CMD_SLEEP);
                    STOP_Flag = 0;
                    EIE |= 0x08;
                    PCON = 0x02;
                    _nop_();
                    _nop_();
                    _nop_();
                    _nop_();
                    _nop_();
                    _nop_();
                    _nop_();
                }
                
                if(Search_Flag||KEY_Pair)
                {
                    StrobeCmd(CMD_STBY);
                    break;
                }
            }
#else
            while(1)
            {
                for(i=0;i<3;i++)
                {
                    SetCH(Pair_Tab[i]);
                    A8101_WriteReg(TXDATA_REG     ,~0x81);
                    A8101_WriteReg(TXDATA_REG + 1 ,~0x01);
                    StrobeCmd(CMD_TX);
                    while((A8101_ReadReg(STROBE_REG)&0x80)==0x80);
                    if((A8101_ReadReg(STROBE_REG)&0x08)==0x08)
                    {
                        Search_Flag = 1;
                        break;
                    }
                }

                if(Search_Flag||KEY_Pair)
                    break;
            }
#endif
            if(Search_Flag||KEY_Pair)
            {
                STOP_Flag = 0;
                StrobeCmd(CMD_STBY);
                A8101_WriteReg(RCOSC3_REG,0x10);
                EIE &= 0xF7;    //disable RFINT
            }
        }
    }

#else

    if(~KEY_Pair)
    {
        Uint16 i;
        Uint8 tmp;
        Uint8 code *readPtr;

        Search_Flag = 0;
        readPtr = (Uint8*)IAP_ADDRESS;
        tmp = *readPtr;

        if(tmp==0xFF)
        {
            ReadFlash(IAP_ADDRESS,Check_ID,6);
            A8101_WriteReg(ID_REG+4,Check_ID[2]);
            A8101_WriteReg(ID_REG+5,Check_ID[3]);
            A8101_WriteReg(ID_REG+6,Check_ID[4]);
            A8101_WriteReg(ID_REG+7,Check_ID[5]);
        }
        else
            A8101_WriteID();

        if(LINK_FAIL)
        {
            P1_2 = 0;
            P1 &= 0x07;
            STOP_Flag = 0;
            Pair_index = 0;
            A8101_WriteReg(CODE1_REG,0x1C);
            A8101_WriteReg(CODE2_REG,0x8E); //Enable Data filter by CRC
            A8101_WriteReg(FIFO1_REG,0x01); //FIFO length = 2 bytes
            A8101_WriteReg(FIFO2_REG,0x00);
            A8101_WriteReg(FCR_REG,0x02);   //Ack enable
            A8101_WriteReg(CKO_REG,0x72);
            A8101_WriteReg(GIO1_REG,0x00);
            A8101_WriteReg(GIO2_REG,0x10);

            for(i=0;i<1000;i++)
            {
                SetCH(Pair_Tab[Pair_index]);
                Pair_index++;
                if(Pair_index>2)
                    Pair_index = 0;
                StrobeCmd(CMD_RX);
                TIMEBASE = 5000;
                InitTimer0();
                IP |= 0x02;
                while((~Timer_Flag)&&((A8101_ReadReg(STROBE_REG)&0x80)==0x80));
                IP &= 0xFD;
                TR0 = 0;
                if((A8101_ReadReg(STROBE_REG)&0x80)==0x80)
                    StrobeCmd(CMD_STBY);
                else
                {
                    Search_Flag = 1;
                    break;
                }

                if(KEY_Pair)
                    break;
            }
            LINK_FAIL = 0;
        }

        if((~Search_Flag)&&(~KEY_Pair))
        {
            P1_2 = 0;
            P1 &= 0x07;
            STOP_Flag = 0;
            Pair_index = 0;
            A8101_WriteReg(CODE1_REG,0x1C);
            A8101_WriteReg(CODE2_REG,0x8E);     //Enable Data filter by CRC
            A8101_WriteReg(FIFO1_REG,0x01);     //FIFO length = 2 bytes
            A8101_WriteReg(FIFO2_REG,0x00);
            A8101_WriteReg(FCR_REG,0x0B);       //Ack enable
            A8101_WriteReg(RCOSC1_REG,0x7C);
            A8101_WriteReg(RCOSC2_REG,0x00);
            A8101_WriteReg(CKO_REG,0x72);
            A8101_WriteReg(GIO1_REG,0x00);
            A8101_WriteReg(GIO2_REG,0x10);
            MeasureExtADC();
            A8101_WriteReg(RCOSC3_REG,0x17);
            StrobeCmd(CMD_SLEEP);
            EIE |= 0x08;

            PCON = 0x02;
            _nop_();
            _nop_();
            _nop_();
            _nop_();
            _nop_();

            while(1)
            {
                if(Search_Flag||KEY_Pair||Link_response)
                {
                    StrobeCmd(CMD_STBY);
                    A8101_WriteReg(RCOSC3_REG,0x10);
                    EIE &= 0xF7;    //disable RFINT
                    Link_response = 0;
                    break;
                }
                
                if(STOP_Flag)
                {
                    StrobeCmd(CMD_SLEEP);
                    STOP_Flag = 0;
                    EIE |= 0x08;
                    PCON = 0x02;
                    _nop_();
                    _nop_();
                    _nop_();
                    _nop_();
                    _nop_();
                    _nop_();
                }
            }
        }
    }
#endif
}

/****************************************
*Pair ID                                *
****************************************/
void Pair_ID(void)
{
#ifdef Master
    Uint16 i,j,k;
    Uint8 tmp,RND_ID1,RND_ID2,buf[6];
    Uint8 code *readPtr;

    if(KEY_Pair)
    {
        P1_2 = 0;
        P1 &= 0x07;
        Pair_OK = 0;
        readPtr = (Uint8*)IAP_ADDRESS;
        tmp = *readPtr;

        A8101_WriteID();
        for(i=0;i<4;i++)
            New_ID[i] = 0x00;

        A8101_WriteReg(CODE1_REG,0x1C);
        A8101_WriteReg(CODE2_REG,0x8E);
        A8101_WriteReg(FIFO1_REG,0x03);     //FIFO length = 4 bytes
        A8101_WriteReg(FIFO2_REG,0x00);
        A8101_WriteReg(FCR_REG,0x09);       //resend enable, times = 2  (ALL: 1+2=3)
        A8101_WriteReg(CKO_REG,0x72);
        A8101_WriteReg(GIO1_REG,0x00);
        A8101_WriteReg(GIO2_REG,0x10);
        MeasureExtADC();
        while(~P0_7);
        KEY_Pair = 0;
        TR0 = 0;
        Random_Flag = 0;
        RND_ID1 = TH0;
        RND_ID2 = TL0;
        for(i=0;i<4;i++)
        {
            tmp = (RND_ID1&(0x01<<i))>>i;
            if(tmp)
                New_ID[0] = (New_ID[0]|(0x02<<(4-(i+1))*2));
            else
                New_ID[0] = (New_ID[0]|(0x01<<(4-(i+1))*2));
        }
        for(i=4;i<8;i++)
        {
            tmp = (RND_ID1&(0x01<<i))>>i;
            if(tmp)
                New_ID[1] = (New_ID[1]|(0x02<<(4-(i-3))*2));
            else
                New_ID[1] = (New_ID[1]|(0x01<<(4-(i-3))*2));
        }
        for(i=0;i<4;i++)
        {
            tmp = (RND_ID2&(0x01<<i))>>i;
            if(tmp)
                New_ID[2] = (New_ID[2]|(0x02<<(4-(i+1))*2));
            else
                New_ID[2] = (New_ID[2]|(0x01<<(4-(i+1))*2));
        }
        for(i=4;i<8;i++)
        {
            tmp = (RND_ID2&(0x01<<i))>>i;
            if(tmp)
                New_ID[3] = (New_ID[3]|(0x02<<(4-(i-3))*2));
            else
                New_ID[3] = (New_ID[3]|(0x01<<(4-(i-3))*2));
        }
        A8101_WriteReg(TXDATA_REG     ,New_ID[0]);
        A8101_WriteReg(TXDATA_REG + 1 ,New_ID[1]);
        A8101_WriteReg(TXDATA_REG + 2 ,New_ID[2]);
        A8101_WriteReg(TXDATA_REG + 3 ,New_ID[3]);

        for(j=0;j<1000;j++)
        {
            for(i=0;i<3;i++)
            {
                SetCH(Pair_Tab[i]);
                StrobeCmd(CMD_TX);
                while(((A8101_ReadReg(STROBE_REG)&0x80)==0x80));
                if((A8101_ReadReg(STROBE_REG)&0x08)==0x08)
                {
                    Pair_OK = 1;
                    A8101_WriteReg(ID_REG+4 , New_ID[0]);
                    A8101_WriteReg(ID_REG+5 , New_ID[1]);
                    A8101_WriteReg(ID_REG+6 , New_ID[2]);
                    A8101_WriteReg(ID_REG+7 , New_ID[3]);
                    buf[0] = 0xFF;
                    buf[1] = 0xFF;
                    for(k=0;k<4;k++)
                        buf[k+2] = New_ID[k];
                    SectorErase(IAP_ADDRESS);
                    WriteFlash(IAP_ADDRESS,buf,6);
                    ReadFlash(IAP_ADDRESS,Check_ID,6);
                    if(memcmp(buf,Check_ID,6) != 0)
                    {
                        SectorErase(IAP_ADDRESS);
                    }
                    break;
                }
            }

            if((j==0)||(j==200)||(j==400)||(j==600)||(j==800)||(j==1000))
                P1_2 = ~P1_2;

            if(KEY_Pair)
                break;

            if(Pair_OK)
            {
                P1_2 = 1;
                break;
            }
        }
    }
    else
    {
        P1_2 = 0;
        P1 &= 0x07;
        Pair_OK = 0;
        readPtr = (Uint8*)IAP_ADDRESS;
        tmp = *readPtr;

        if(tmp==0xFF)
        {
            ReadFlash(IAP_ADDRESS,Check_ID,6);
            A8101_WriteReg(ID_REG+4,Check_ID[2]);
            A8101_WriteReg(ID_REG+5,Check_ID[3]);
            A8101_WriteReg(ID_REG+6,Check_ID[4]);
            A8101_WriteReg(ID_REG+7,Check_ID[5]);
            A8101_WriteReg(TXDATA_REG     ,Check_ID[2]);
            A8101_WriteReg(TXDATA_REG + 1 ,Check_ID[3]);
            A8101_WriteReg(TXDATA_REG + 2 ,Check_ID[4]);
            A8101_WriteReg(TXDATA_REG + 3 ,Check_ID[5]);
        }
        else
        {
            A8101_WriteID();
            A8101_WriteReg(TXDATA_REG     ,0xEA);
            A8101_WriteReg(TXDATA_REG + 1 ,0x45);
            A8101_WriteReg(TXDATA_REG + 2 ,0x33);
            A8101_WriteReg(TXDATA_REG + 3 ,0xC7);
        }

        A8101_WriteReg(CODE1_REG,0x1C);
        A8101_WriteReg(CODE2_REG,0x8E);
        A8101_WriteReg(FIFO1_REG,0x03);     //FIFO length = 4 bytes
        A8101_WriteReg(FIFO2_REG,0x00);
        A8101_WriteReg(FCR_REG,0x09);       //resend enable, times = 2  (ALL: 1+2=3)
        A8101_WriteReg(CKO_REG,0x72);
        A8101_WriteReg(GIO1_REG,0x00);
        A8101_WriteReg(GIO2_REG,0x10);
        MeasureExtADC();
        for(j=0;j<1000;j++)
        {
            for(i=0;i<3;i++)
            {
                SetCH(Pair_Tab[i]);
                StrobeCmd(CMD_TX);
                while(((A8101_ReadReg(STROBE_REG)&0x80)==0x80));
                if((A8101_ReadReg(STROBE_REG)&0x08)==0x08)
                {
                    readPtr = (Uint8*)IAP_ADDRESS;
                    tmp = *readPtr;

                    if(tmp!=0xFF)
                    {
                        A8101_WriteReg(ID_REG+4,0xEA);
                        A8101_WriteReg(ID_REG+5,0x45);
                        A8101_WriteReg(ID_REG+6,0x33);
                        A8101_WriteReg(ID_REG+7,0xC7);
                    }
                    Pair_OK = 1;
                    break;
                }
                else
                {
                    while((A8101_ReadReg(STROBE_REG)&0x80)==0x80);
                    break;
                }
            }

            if((j==0)||(j==200)||(j==400)||(j==600)||(j==800)||(j==1000))
                P1_2 = ~P1_2;

            if(KEY_Pair)
                break;

            if(Pair_OK)
            {
                P1_2 = 1;
                break;
            }
        }
    }
#else
    Uint8 tmp,keypress,buf[6],k;
    Uint8 code *readPtr;
    Uint16 i;

    P1_2 = 0;
    P1 &= 0x07;
    Pair_OK  = 0;
    Pair_index = 0;
    while(~P0_7);

    if(KEY_Pair)
    {
        A8101_WriteID();
        keypress = 1;
    }
    else
    {
        keypress = 0;
        readPtr = (Uint8*)IAP_ADDRESS;
        tmp = *readPtr;

        if(tmp==0xFF)
        {
            ReadFlash(IAP_ADDRESS,Check_ID,6);
            A8101_WriteReg(ID_REG+4,Check_ID[2]);
            A8101_WriteReg(ID_REG+5,Check_ID[3]);
            A8101_WriteReg(ID_REG+6,Check_ID[4]);
            A8101_WriteReg(ID_REG+7,Check_ID[5]);
        }
        else
            A8101_WriteID();
    }
    KEY_Pair = 0;

    A8101_WriteReg(CODE1_REG,0x1C);
    A8101_WriteReg(CODE2_REG,0x8E);
    A8101_WriteReg(FIFO1_REG,0x03);	    //FIFO length = 4 bytes
    A8101_WriteReg(FIFO2_REG,0x00);     //FIFO length = 2 bytes
    A8101_WriteReg(FCR_REG,0x02);       //ACK enable
    A8101_WriteReg(CKO_REG,0x72);
    A8101_WriteReg(GIO1_REG,0x00);
    A8101_WriteReg(GIO2_REG,0x10);

    for(i=0;i<500;i++)
    {
        SetCH(Pair_Tab[Pair_index]);
        Pair_index++;
        if(Pair_index>2)
            Pair_index = 0;
        StrobeCmd(CMD_RX);
        TIMEBASE = 16000;
        InitTimer0();
        while((~Timer_Flag)&&((A8101_ReadReg(STROBE_REG)&0x80)==0x80));
        TR0 = 0;
        if((A8101_ReadReg(STROBE_REG)&0x80)==0x80)
            StrobeCmd(CMD_STBY);
        else
        {
            tmp = A8101_ReadReg(RXDATA_REG);
            A8101_WriteReg(ID_REG +4 ,tmp);
            tmp = A8101_ReadReg(RXDATA_REG +1);
            A8101_WriteReg(ID_REG +5 ,tmp);
            tmp = A8101_ReadReg(RXDATA_REG +2);
            A8101_WriteReg(ID_REG +6 ,tmp);
            tmp = A8101_ReadReg(RXDATA_REG +3);
            A8101_WriteReg(ID_REG +7 ,tmp);
            if(keypress)
            {
                buf[0] = 0xFF;
                buf[1] = 0xFF;
                for(k=0;k<4;k++)
                    buf[k+2] = A8101_ReadReg(RXDATA_REG+k);
                SectorErase(IAP_ADDRESS);
                WriteFlash(IAP_ADDRESS,buf,6);
                ReadFlash(IAP_ADDRESS,Check_ID,6);
                if(memcmp(buf,Check_ID,6) != 0)
                {
                    SectorErase(IAP_ADDRESS);
                }
            }
            Pair_OK = 1;
            break;
        }

        if((i==0)||(i==100)||(i==200)||(i==300)||(i==400)||(i==500))
            P1_2 = ~P1_2;

        if(KEY_Pair)
            break;
    }

    if(Pair_OK)
        P1_2 = 1;
    else
        P1_2 = 0;
#endif
}

/****************************************
*System Link                            *
****************************************/
void System_Link(void)
{
#ifdef Master
    Uint8 i,n;
    if(Pair_OK)
    {
				pcs = 10;					// Set monitor times of Channel hopping
				max = 5;					// Set max of package loss
				close_max = 5;		// Set max of Close Channel 
				close = 0;
        P1_2 = 1;
        P1 &= 0x07;
        BufGroup = 0;
        BufIndex = 0;
        DataTxFlag = 0;
        Link_Quality = 0;
        Update_Flag = 0;
        ACK_Flag = 0;
        TX_Active = 1;
        Link_index = 0;
        TalkBackFlag = 0;
        Channel_number = 36;
        CH_STATE[0] = 0x0F;
        for(i=1;i<5;i++)
            CH_STATE[i] = 0xFF;
        New_CH_STATE[0] = 0x0F;
        for(i=1;i<5;i++)
            New_CH_STATE[i] = 0xFF;
				for(i=0;i<36;i++) 
				{
						CH_TABLE[0][i] = Hop_Tab[i];
						CH_TABLE[1][i] = 0;
						CH_TABLE[2][i] = 0;
				}
        MAX_VOL = 0;
        TIMEBASE = 240;

        A8101_WriteReg(CODE1_REG,0x1C);
        A8101_WriteReg(CODE2_REG,0x8E);     //0x8E  enable CRC filtering
        A8101_WriteReg(FCR_REG,0x00);       //resend disable
        A8101_WriteReg(GIO1_REG,0x00);
        A8101_WriteReg(GIO2_REG,0x10);
        A8101_WriteReg(CKO_REG,0x02);
        InitCodec();
        EIE |=0x02;
        ResetCmd(FIFODATA_RST);
        A8101_WriteReg(CODEC_CODECTL,0xB0);
        Delay1ms(500);
        A8101_WriteReg(CODEC_OSCAL2,0x1A);
        DataTxFlag = 0;
        while(1)
        {
#ifdef AFH
						Select_Close_Channel();
#endif						
            XBYTE[FIFO1_REG] = 0x48;
						
            if(Channel_number < 3)
            {
                close = 0;
								Channel_number = 36;
								New_CH_STATE[0] = 0x0F;
								New_CH_STATE[1] = 0xFF; 
								New_CH_STATE[2] = 0xFF;
								New_CH_STATE[3] = 0xFF;
								New_CH_STATE[4] = 0xFF;
								CH_STATE[0] = 0x0F;
								for(i=1;i<5;i++)
									CH_STATE[i] = 0xFF;				
								New_CH_STATE[0] = 0x0F;				
								for(i=1;i<5;i++)
									New_CH_STATE[i] = 0xFF;	
								for(i=0;i<36;i++) 
								{
										CH_TABLE[0][i] = Hop_Tab[i];
										CH_TABLE[1][i] = 0;
										CH_TABLE[2][i] = 0;
								}
            }		
						
						Channel_Index(Link_index);
            SetCH(Hop_Tab[Link_index]);
            MeasureExtADC();
            while((~KEY_Pair)&&(~DataTxFlag));
            while((~KEY_Pair)&&((XBYTE[STROBE_REG]&0x80)==0x80));

            if(~KEY_Pair)
            {
                for(i=0;i<64;i++)
                    XBYTE[TXDATA_REG+i] = CODECBUF[~BufGroup][i];

                StrobeCmd(CMD_TX);
                XBYTE[TXDATA_REG+64] = (0x10|New_CH_STATE[0]|(((Uint8)Update_Flag)<<7));
                XBYTE[TXDATA_REG+65] = New_CH_STATE[1];
                XBYTE[TXDATA_REG+66] = New_CH_STATE[2];
                XBYTE[TXDATA_REG+67] = New_CH_STATE[3];
                XBYTE[TXDATA_REG+68] = New_CH_STATE[4];
                XBYTE[TXDATA_REG+69] = Temperature;
                XBYTE[TXDATA_REG+70] = MAX_VOL;
                XBYTE[TXDATA_REG+71] = 0x00;
                XBYTE[TXDATA_REG+72] = 0x00;
                MAX_VOL = 0;
                DataTxFlag = 0;
                while(((XBYTE[STROBE_REG]&0x80)==0x80));
                Update_Flag = 0;
                XBYTE[FIFO1_REG] = 0x04;
                StrobeCmd(CMD_RX);
                InitTimer0();
                while((Timer_Flag==0)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                TR0 = 0;
                if((XBYTE[STROBE_REG]&0x80)==0x80)
                {
                    StrobeCmd(CMD_STBY);
                    // close channel
										Close_Index(Link_index);
										//
									
                    ACK_Flag = 0;	

										if(Channel_number < 3)
										{
												Channel_number = 36;
												New_CH_STATE[0] = 0x0F;
												New_CH_STATE[1] = 0xFF;
												New_CH_STATE[2] = 0xFF;
												New_CH_STATE[3] = 0xFF;
												New_CH_STATE[4] = 0xFF;
										}	
										
										Search_Channel();
														
										Channel_Index(Link_index);
                    SetCH(Hop_Tab[Link_index]);
                    XBYTE[FIFO1_REG] = 0x48;
                    StrobeCmd(CMD_TX);
                    XBYTE[TXDATA_REG+64] = (0x20|New_CH_STATE[0]|(((Uint8)Update_Flag)<<7));
                    XBYTE[TXDATA_REG+65] = New_CH_STATE[1];
                    XBYTE[TXDATA_REG+66] = New_CH_STATE[2];
                    XBYTE[TXDATA_REG+67] = New_CH_STATE[3];
                    XBYTE[TXDATA_REG+68] = New_CH_STATE[4];
                    while(((XBYTE[STROBE_REG]&0x80)==0x80));
                    Update_Flag = 0;
                    XBYTE[FIFO1_REG] = 0x04;
                    StrobeCmd(CMD_RX);
                    InitTimer0();
                    while((Timer_Flag==0)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                    TR0 = 0;
                    if((XBYTE[STROBE_REG]&0x80)==0x80)
                    {
                        StrobeCmd(CMD_STBY);
                        // close channel
												Close_Index(Link_index);
												//
											
                        ACK_Flag = 0;   

												if(Channel_number < 3)
												{
														Channel_number = 36;
														New_CH_STATE[0] = 0x0F;
														New_CH_STATE[1] = 0xFF;
														New_CH_STATE[2] = 0xFF;
														New_CH_STATE[3] = 0xFF;
														New_CH_STATE[4] = 0xFF;
												}																

												Search_Channel();
												
												Channel_Index(Link_index);
                        SetCH(Hop_Tab[Link_index]);
                        XBYTE[FIFO1_REG] = 0x48;
                        StrobeCmd(CMD_TX);
                        XBYTE[TXDATA_REG+64] = (0x30|New_CH_STATE[0]|(((Uint8)Update_Flag)<<7));
                        XBYTE[TXDATA_REG+65] = New_CH_STATE[1];
                        XBYTE[TXDATA_REG+66] = New_CH_STATE[2];
                        XBYTE[TXDATA_REG+67] = New_CH_STATE[3];
                        XBYTE[TXDATA_REG+68] = New_CH_STATE[4];
                        while(((XBYTE[STROBE_REG]&0x80)==0x80));
                        Update_Flag = 0;
                        XBYTE[FIFO1_REG] = 0x04;
                        StrobeCmd(CMD_RX);
                        InitTimer0();
                        while((Timer_Flag==0)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                        TR0 = 0;

                        if((XBYTE[STROBE_REG]&0x80)==0x80)
                        {
                            StrobeCmd(CMD_STBY);
                            // close channel
														Close_Index(Link_index);
														//
													
                            ACK_Flag = 0;
                            Link_Quality++;
                        }
                        else
                        {
                            Link_Quality = 0;														
                            RSSI = XBYTE[RSSI_REG];
                            ACK_Flag = XBYTE[RXDATA_REG]&0x01;
                            TalkBackFlag = (XBYTE[RXDATA_REG]&0x02)>>1;
														New_Channel_Table();															
                        }
                    }
                    else
                    {
                        Link_Quality = 0;												
                        RSSI = XBYTE[RSSI_REG];
                        ACK_Flag = XBYTE[RXDATA_REG]&0x01;
                        TalkBackFlag = (XBYTE[RXDATA_REG]&0x02)>>1;												
												Search_Channel();											
												New_Channel_Table();													
                    }
                }
                else
                {
                    Link_Quality = 0;
                    RSSI = XBYTE[RSSI_REG];
                    ACK_Flag = XBYTE[RXDATA_REG]&0x01;
                    TalkBackFlag = (XBYTE[RXDATA_REG]&0x02)>>1;
                    Search_Channel();
										Search_Channel();
										New_Channel_Table();											
                }
                Search_Channel();
            }

            if(KEY_Pair||(Link_Quality>200)||TalkBackFlag)
            {
                if((XBYTE[RST_REG]&0x03)==0x01)
                    StrobeCmd(CMD_STBY);
                while((XBYTE[STROBE_REG]&0x80)==0x80);
                A8101_WriteReg(CODEC_ANACTL,0x00);
                A8101_WriteReg(CODEC_CODECTL,0x00);
                EIE &= 0xFD;
                P1_2 = 0;
                break;
            }
        }

        if(Link_Quality>200)
            LINK_FAIL = 1;

        if(TalkBackFlag)
        {
            BufGroup = 0;
            Link_Quality = 0;
            P1_2 = 1;
            P1 &= 0x07;
            TIMEOUT = 0;
            TIMECNT = 0;
            TalkBackFlag = 0;
            First_Link = 1;
            MAX_VOL = 0;
            CH_STATE[0] = 0x0F;
            for(i=1;i<5;i++)
                CH_STATE[i] = 0xFF;
            New_CH_STATE[0] = 0x0F;
            for(i=1;i<5;i++)
                New_CH_STATE[i] = 0xFF;

            A8101_WriteReg(CODE1_REG,0x1C);
            A8101_WriteReg(CODE2_REG,0x8E);
            A8101_WriteReg(FCR_REG,0x00);   //ACK disable
            A8101_WriteReg(CKO_REG,0x02);
            A8101_WriteReg(GIO1_REG,0x00);
            A8101_WriteReg(GIO2_REG,0x10);

            A8101_WriteReg(CODEC_CODECTL,0x00);
            A8101_WriteReg(CODEC_SRSEL,0x02);
            A8101_WriteReg(CODEC_AMP,0x5F);
            A8101_WriteReg(CODEC_DACWB,0xAA);
            _nop_();
            _nop_();
            A8101_WriteReg(CODEC_DACWB,0xAA);
            _nop_();
            _nop_();
            A8101_WriteReg(CODEC_VOL,0x3F);
            A8101_WriteReg(CODEC_ANACTL,0x60);
            A8101_WriteReg(CODEC_TESTMODE,0x10);
            EIE |= 0x04;


            VOL_Level = 9;
            ResetCmd(FIFODATA_RST);
            Link_index = 0;
            SetCH(Hop_Tab[Link_index]);
            XBYTE[FIFO1_REG] = 0x48;
            StrobeCmd(CMD_RX);
            TIMEBASE = 65536;
            InitTimer0();
            while((~KEY_Pair)&&((XBYTE[STROBE_REG]&0x80)==0x80)&&(TIMEOUT==0));
            First_Link = 0;
            TR0 = 0;
            if(~KEY_Pair&&(TIMEOUT==0))
            {
                if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                    TIMEBASE = 4350;
                else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                    TIMEBASE = 3080;
                else
                    TIMEBASE = 1800;

                InitTimer0();
                Delay15us(2);
                XBYTE[FIFO1_REG] = 0x04;
                StrobeCmd(CMD_TX);
                XBYTE[TXDATA_REG] = ((((Uint8)TalkBackFlag)<<1)|ACK_Flag);

                for(i=0;i<64;i++)
                    CODECBUF[0][i] = XBYTE[RXDATA_REG+i];

                RSSI = XBYTE[RSSI_REG];
                Temperature = XBYTE[RXDATA_REG+69];
                MAX_VOL = XBYTE[RXDATA_REG+70];

                while((XBYTE[STROBE_REG]&0x80)==0x80);

                if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                {
                    n = 1;
                    do{
                        Link_index++;
                        if(Link_index>35)
                            Link_index = 0;
                    }while(n--);
                }
                else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                {
                    Link_index++;
                    if(Link_index>35)
                        Link_index = 0;
                }
            }
            else
            {
                StrobeCmd(CMD_STBY);
                while((XBYTE[STROBE_REG]&0x80)==0x80);
            }

            if(TIMEOUT==0)
            {
                Link_index++;
                if(Link_index>35)
                    Link_index = 0;
                SetCH(Hop_Tab[Link_index]);
                XBYTE[FIFO1_REG] = 0x48;
                while(~Timer_Flag);
                StrobeCmd(CMD_RX);
                TIMEBASE = 1150;
                InitTimer0();
                while((~KEY_Pair)&&(~Timer_Flag)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                TR0 = 0;
                if(KEY_Pair)
                {
                }
                else if(Timer_Flag)
                {
                    StrobeCmd(CMD_STBY);
                    Link_index++;
                    if(Link_index>35)
                        Link_index = 0;
                    SetCH(Hop_Tab[Link_index]);
                    StrobeCmd(CMD_RX);
                    TIMEBASE = 1270;
                    InitTimer0();
                    while((~KEY_Pair)&&(~Timer_Flag)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                    TR0 = 0;
                    if(KEY_Pair)
                    {
                    }
                    else if(Timer_Flag)
                    {
                        StrobeCmd(CMD_STBY);
                        Link_index++;
                        if(Link_index>35)
                            Link_index = 0;
                        SetCH(Hop_Tab[Link_index]);
                        TIMEOUT = 0;
                        TIMEBASE = 65536;
                        First_Link = 1;
                        InitTimer0();
                        StrobeCmd(CMD_RX);
                        while((~KEY_Pair)&&((XBYTE[STROBE_REG]&0x80)==0x80)&&(TIMEOUT==0));
                        TR0 = 0;
                        First_Link = 0;
                        if(~KEY_Pair&&(TIMEOUT==0))
                        {
                            if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                                TIMEBASE = 4350;
                            else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                                TIMEBASE = 3080;
                            else
                                TIMEBASE = 1800;

                            InitTimer0();

                            Delay15us(2);

                            XBYTE[FIFO1_REG] = 0x04;
                            StrobeCmd(CMD_TX);
                            XBYTE[TXDATA_REG] = ((((Uint8)TalkBackFlag)<<1)|ACK_Flag);

                            for(i=0;i<64;i++)
                                CODECBUF[1][i] = XBYTE[RXDATA_REG+i];

                            RSSI = XBYTE[RSSI_REG];
                            Temperature = XBYTE[RXDATA_REG+69];
                            MAX_VOL = XBYTE[RXDATA_REG+70];

                            while((XBYTE[STROBE_REG]&0x80)==0x80);

                            if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                            {
                                n = 1;
                                do{
                                    Link_index++;
                                    if(Link_index>35)
                                        Link_index = 0;
                                }while(n--);
                            }
                            else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                            {
                                Link_index++;
                                if(Link_index>35)
                                    Link_index = 0;
                            }
                        }
                        else
                        {
                            StrobeCmd(CMD_STBY);
                            while((XBYTE[STROBE_REG]&0x80)==0x80);
                        }
                    }
                    else
                    {
                        if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                            TIMEBASE = 4350;
                        else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                            TIMEBASE = 3080;
                        else
                            TIMEBASE = 1800;

                        InitTimer0();

                        Delay15us(2);

                        XBYTE[FIFO1_REG] = 0x04;
                        StrobeCmd(CMD_TX);
                        XBYTE[TXDATA_REG] = ((((Uint8)TalkBackFlag)<<1)|ACK_Flag);

                        for(i=0;i<64;i++)
                            CODECBUF[1][i] = XBYTE[RXDATA_REG+i];

                        RSSI = XBYTE[RSSI_REG];
                        Temperature = XBYTE[RXDATA_REG+69];
                        MAX_VOL = XBYTE[RXDATA_REG+70];

                        while((XBYTE[STROBE_REG]&0x80)==0x80);

                        Link_index++;
                        if(Link_index>35)
                            Link_index = 0;
                    }
                }
                else
                {
                    if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                        TIMEBASE = 4350;
                    else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                        TIMEBASE = 3080;
                    else
                        TIMEBASE = 1800;

                    InitTimer0();
                    Delay15us(2);

                    XBYTE[FIFO1_REG] = 0x04;
                    StrobeCmd(CMD_TX);
                    XBYTE[TXDATA_REG] = ((((Uint8)TalkBackFlag)<<1)|ACK_Flag);
                    for(i=0;i<64;i++)
                        CODECBUF[1][i] = XBYTE[RXDATA_REG+i];

                    RSSI = XBYTE[RSSI_REG];
                    Temperature = XBYTE[RXDATA_REG+69];
                    MAX_VOL = XBYTE[RXDATA_REG+70];

                    while((XBYTE[STROBE_REG]&0x80)==0x80);

                    n = 1;
                    do{
                        Link_index++;
                        if(Link_index>35)
                            Link_index = 0;
                    }while(n--);
                }
            }

            if(TIMEOUT==0)
            {
                A8101_WriteReg(CODEC_CODECTL,0x03);
                A8101_WriteReg(CODEC_ESTEPL,0xFF);
                A8101_WriteReg(CODEC_ESTEPH,0x00);
                A8101_WriteReg(CODEC_EFFCTL,0x02);
                BufEmpty = 1;
                if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                    BufIndex = 36;
                else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                    BufIndex = 52;
                else
                    BufIndex = 5;

                while(1)
                {
                    Link_index++;
                    while((~KEY_Pair)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                    XBYTE[FIFO1_REG] = 0x48;
                    if(Link_index>35)
                        Link_index = 0;

                    SetCH(Hop_Tab[Link_index]);
                    MeasureExtADC();
                    while(~Timer_Flag);
                    StrobeCmd(CMD_RX);
                    TIMEBASE = 1150;
                    InitTimer0();
                    while((~KEY_Pair)&&(~Timer_Flag)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                    TR0 = 0;
                    if((XBYTE[STROBE_REG]&0x80)==0x80)
                    {
                        if(KEY_Pair)
                            break;
                        else
                        {
                            StrobeCmd(CMD_STBY);
                            Link_index ++;
                            if(Link_index>35)
                                Link_index = 0;
                            SetCH(Hop_Tab[Link_index]);
                            StrobeCmd(CMD_RX);
                            TIMEBASE = 1270;
                            InitTimer0();
                            while((~KEY_Pair)&&(~Timer_Flag)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                            TR0 = 0;
                            if((XBYTE[STROBE_REG]&0x80)==0x80)
                            {
                                if(KEY_Pair)
                                    break;
                                else
                                {
                                    StrobeCmd(CMD_STBY);
                                    Link_index ++;
                                    if(Link_index>35)
                                        Link_index = 0;
                                    SetCH(Hop_Tab[Link_index]);
                                    StrobeCmd(CMD_RX);
                                    TIMEBASE = 1270;
                                    InitTimer0();
                                    while((~KEY_Pair)&&(~Timer_Flag)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                                    TR0 = 0;
                                    if((XBYTE[STROBE_REG]&0x80)==0x80)
                                    {
                                        if(KEY_Pair)
                                            break;
                                        else
                                        {
                                            StrobeCmd(CMD_STBY);
                                            TIMEBASE = 1600;
                                            InitTimer0();
                                            Link_Quality++;
                                            if(Link_Quality>2)
                                                A8101_WriteReg(CODEC_EFFCTL,0x06);
                                        }
                                    }
                                    else
                                    {
                                        if(Link_Quality != 0)
                                        {
                                            A8101_WriteReg(CODEC_EFFCTL,0x02);
                                            Link_Quality = 0;
                                        }

                                        if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                                            TIMEBASE = 4350;
                                        else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                                            TIMEBASE = 3080;
                                        else
                                            TIMEBASE = 1800;

                                        InitTimer0();

                                        XBYTE[FIFO1_REG] = 0x04;
                                        StrobeCmd(CMD_TX);
                                        XBYTE[TXDATA_REG] = ((((Uint8)TalkBackFlag)<<1)|ACK_Flag);
                                        RSSI = XBYTE[RSSI_REG];
                                        Temperature = XBYTE[RXDATA_REG+69];
                                        MAX_VOL = XBYTE[RXDATA_REG+70];

                                        while(BufEmpty&&(~KEY_Pair));

                                        for(i=0;i<64;i++)
                                            CODECBUF[~BufGroup][i] = XBYTE[RXDATA_REG+i];

                                        DisplayBar();
                                        BufEmpty = 1;
                                    }
                                }
                            }
                            else
                            {
                                if(Link_Quality != 0)
                                {
                                    A8101_WriteReg(CODEC_EFFCTL,0x02);
                                    Link_Quality = 0;
                                }

                                if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                                    TIMEBASE = 4350;
                                else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                                    TIMEBASE = 3080;
                                else
                                    TIMEBASE = 1800;

                                InitTimer0();
                                XBYTE[FIFO1_REG] = 0x04;
                                StrobeCmd(CMD_TX);
                                XBYTE[TXDATA_REG] = ((((Uint8)TalkBackFlag)<<1)|ACK_Flag);
                                RSSI = XBYTE[RSSI_REG];
                                Temperature = XBYTE[RXDATA_REG+69];
                                MAX_VOL = XBYTE[RXDATA_REG+70];

                                while(BufEmpty&&(~KEY_Pair));

                                for(i=0;i<64;i++)
                                    CODECBUF[~BufGroup][i] = XBYTE[RXDATA_REG+i];

                                DisplayBar();

                                BufEmpty = 1;
                                Link_index ++;
                                if(Link_index>35)
                                    Link_index = 0;
                            }
                        }
                    }
                    else
                    {
                        if(Link_Quality != 0)
                        {
                            A8101_WriteReg(CODEC_EFFCTL,0x02);
                            Link_Quality = 0;
                        }

                        if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                            TIMEBASE = 4350;
                        else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                            TIMEBASE = 3080;
                        else
                            TIMEBASE = 1800;

                        InitTimer0();

                        XBYTE[FIFO1_REG] = 0x04;
                        StrobeCmd(CMD_TX);
                        XBYTE[TXDATA_REG] = ((((Uint8)TalkBackFlag)<<1)|ACK_Flag);
                        RSSI = XBYTE[RSSI_REG];
                        Temperature = XBYTE[RXDATA_REG+69];
                        MAX_VOL = XBYTE[RXDATA_REG+70];

                        while(BufEmpty&&(~KEY_Pair));

                        for(i=0;i<64;i++)
                            CODECBUF[~BufGroup][i] = XBYTE[RXDATA_REG+i];

                        DisplayBar();
                        BufEmpty = 1;

                        do{
													Link_index++;	
													Link_index++;
													if(Link_index > 35)
														Link_index = 0;
												}while(Hop_Tab[Link_index] == 0xFF);
                    }

                    if(KEY_Pair||(Link_Quality>200))
                    {
                        if((XBYTE[RST_REG]&0x03)==0x01)
                            StrobeCmd(CMD_STBY);

                        while((XBYTE[STROBE_REG]&0x80)==0x80);
                        A8101_WriteReg(CODEC_ANACTL,0x00);
                        A8101_WriteReg(CODEC_CODECTL,0x00);
                        P1_2 = 0;
                        break;
                    }
                }
            }

            if(KEY_Pair||(Link_Quality>200)||TIMEOUT)
            {
                if((XBYTE[RST_REG]&0x03)==0x01)
                    StrobeCmd(CMD_STBY);

                while((XBYTE[STROBE_REG]&0x80)==0x80);
                A8101_WriteReg(CODEC_ANACTL,0x00);
                A8101_WriteReg(CODEC_CODECTL,0x00);
                P1_2 = 0;
            }

            LINK_FAIL = 1;
        }
    }

#else

    Uint8 i,n;

    if(Pair_OK)
    {
        BufGroup = 0;
        Link_Quality = 0;
        P1_2 = 1;
        P1 &= 0x07;
        TIMEOUT = 0;
        TIMECNT = 0;
        TalkBackFlag = 0;
        First_Link = 1;
        MAX_VOL = 0;
        CH_STATE[0] = 0x0F;
        for(i=1;i<5;i++)
            CH_STATE[i] = 0xFF;
        New_CH_STATE[0] = 0x0F;
        for(i=1;i<5;i++)
            New_CH_STATE[i] = 0xFF;
				for(i=0;i<36;i++) 
						CH_TABLE[0][i] = Hop_Tab[i];
        A8101_WriteReg(CODE1_REG,0x1C);
        A8101_WriteReg(CODE2_REG,0x8E);
        A8101_WriteReg(FCR_REG,0x00);   //ACK disable
        A8101_WriteReg(CKO_REG,0x02);
        A8101_WriteReg(GIO1_REG,0x00);
        A8101_WriteReg(GIO2_REG,0x10);
        InitCodec();
        VOL_Level = 9;
        ResetCmd(FIFODATA_RST);
        Link_index = 0;
        SetCH(Hop_Tab[Link_index]);
				Channel_number = 36;
        XBYTE[FIFO1_REG] = 0x48;
        StrobeCmd(CMD_RX);
        TIMEBASE = 65536;
        InitTimer0();
        while((~KEY_Pair)&&((XBYTE[STROBE_REG]&0x80)==0x80)&&(TIMEOUT==0));
        First_Link = 0;
        TR0 = 0;
        if(~KEY_Pair&&(TIMEOUT==0))
        {
            if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                TIMEBASE = 4350;
            else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                TIMEBASE = 3080;
            else
                TIMEBASE = 1800;

            InitTimer0();
            Delay15us(2);
            XBYTE[FIFO1_REG] = 0x04;
            StrobeCmd(CMD_TX);
            XBYTE[TXDATA_REG] = ((((Uint8)TalkBackFlag)<<1)|ACK_Flag);

            for(i=0;i<64;i++)
                CODECBUF[0][i] = XBYTE[RXDATA_REG+i];
            RSSI = XBYTE[RSSI_REG];
            Temperature = XBYTE[RXDATA_REG+69];
            MAX_VOL = XBYTE[RXDATA_REG+70];

            while((XBYTE[STROBE_REG]&0x80)==0x80);

            if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
            {
                n = 1;
                do{
                    Link_index++;
                    if(Link_index>35)
                        Link_index = 0;
                }while(n--);
            }
            else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
            {
                Link_index++;
                if(Link_index>35)
                    Link_index = 0;
            }
        }
        else
        {
            StrobeCmd(CMD_STBY);
            while((XBYTE[STROBE_REG]&0x80)==0x80);
        }

        if(TIMEOUT==0)
        {
            Link_index++;
            if(Link_index>35)
                Link_index = 0;
            SetCH(Hop_Tab[Link_index]);
            XBYTE[FIFO1_REG] = 0x48;
            while(~Timer_Flag);
            StrobeCmd(CMD_RX);
            TIMEBASE = 1150;
            InitTimer0();
            while((~KEY_Pair)&&(~Timer_Flag)&&((XBYTE[STROBE_REG]&0x80)==0x80));
            TR0 = 0;
            if(KEY_Pair)
            {
            }
            else if(Timer_Flag)
            {
                StrobeCmd(CMD_STBY);
                Link_index++;
                if(Link_index>35)
                    Link_index = 0;

                SetCH(Hop_Tab[Link_index]);
                StrobeCmd(CMD_RX);
                TIMEBASE = 1270;
                InitTimer0();
                while((~KEY_Pair)&&(~Timer_Flag)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                TR0 = 0;
                if(KEY_Pair)
                {
                }
                else if(Timer_Flag)
                {
                    StrobeCmd(CMD_STBY);
                    Link_index++;
                    if(Link_index>35)
                        Link_index = 0;
                    SetCH(Hop_Tab[Link_index]);
                    TIMEOUT = 0;
                    TIMEBASE = 65536;
                    First_Link = 1;
                    InitTimer0();
                    StrobeCmd(CMD_RX);
                    while((~KEY_Pair)&&((XBYTE[STROBE_REG]&0x80)==0x80)&&(TIMEOUT==0));
                    TR0 = 0;
                    First_Link = 0;
                    if(~KEY_Pair&&(TIMEOUT==0))
                    {
                        if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                            TIMEBASE = 4350;
                        else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                            TIMEBASE = 3080;
                        else
                            TIMEBASE = 1800;

                        InitTimer0();

                        Delay15us(2);

                        XBYTE[FIFO1_REG] = 0x04;
                        StrobeCmd(CMD_TX);
                        XBYTE[TXDATA_REG] = ((((Uint8)TalkBackFlag)<<1)|ACK_Flag);

                        for(i=0;i<64;i++)
                            CODECBUF[1][i] = XBYTE[RXDATA_REG+i];
                        RSSI = XBYTE[RSSI_REG];
                        Temperature = XBYTE[RXDATA_REG+69];
                        MAX_VOL = XBYTE[RXDATA_REG+70];

                        while((XBYTE[STROBE_REG]&0x80)==0x80);

                        if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                        {
                            n = 1;
                            do{
                                Link_index++;
                                if(Link_index>35)
                                    Link_index = 0;
                            }while(n--);
                        }
                        else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                        {
                            Link_index++;
                            if(Link_index>35)
                                Link_index = 0;
                        }
                    }
                    else
                    {
                        StrobeCmd(CMD_STBY);
                        while((XBYTE[STROBE_REG]&0x80)==0x80);
                    }
                }
                else
                {
                    if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                        TIMEBASE = 4350;
                    else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                        TIMEBASE = 3080;
                    else
                        TIMEBASE = 1800;

                    InitTimer0();

                    Delay15us(2);

                    XBYTE[FIFO1_REG] = 0x04;
                    StrobeCmd(CMD_TX);
                    XBYTE[TXDATA_REG] = ((((Uint8)TalkBackFlag)<<1)|ACK_Flag);

                    for(i=0;i<64;i++)
                        CODECBUF[1][i] = XBYTE[RXDATA_REG+i];
                    RSSI = XBYTE[RSSI_REG];
                    Temperature = XBYTE[RXDATA_REG+69];
                    MAX_VOL = XBYTE[RXDATA_REG+70];


                    while((XBYTE[STROBE_REG]&0x80)==0x80);
                    Link_index++;
                    if(Link_index>35)
                        Link_index = 0;
                }
            }
            else
            {
                if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                    TIMEBASE = 4350;
                else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                    TIMEBASE = 3080;
                else
                    TIMEBASE = 1800;

                InitTimer0();

                Delay15us(2);

                XBYTE[FIFO1_REG] = 0x04;
                StrobeCmd(CMD_TX);
                XBYTE[TXDATA_REG] = ((((Uint8)TalkBackFlag)<<1)|ACK_Flag);

                for(i=0;i<64;i++)
                    CODECBUF[1][i] = XBYTE[RXDATA_REG+i];
                RSSI = XBYTE[RSSI_REG];
                Temperature = XBYTE[RXDATA_REG+69];
                MAX_VOL = XBYTE[RXDATA_REG+70];

                while((XBYTE[STROBE_REG]&0x80)==0x80);

                n = 1;
                do{
                    Link_index++;
                    if(Link_index>35)
                        Link_index = 0;
                }while(n--);
            }
        }

        if(TIMEOUT==0)
        {
            A8101_WriteReg(CODEC_CODECTL,0x03);
            A8101_WriteReg(CODEC_ESTEPL,0xFF);
            A8101_WriteReg(CODEC_ESTEPH,0x00);
            A8101_WriteReg(CODEC_EFFCTL,0x02);

            BufEmpty = 1;
            if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                BufIndex = 36;
            else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                BufIndex = 52;
            else
                BufIndex = 5;

            while(1)
            {
								Search_Channel();
							
                while((~KEY_Pair)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                XBYTE[FIFO1_REG] = 0x48;
                SetCH(Hop_Tab[Link_index]);
                MeasureExtADC();
                while(~Timer_Flag);

                StrobeCmd(CMD_RX);
                TIMEBASE = 1150;
                InitTimer0();
                while((~KEY_Pair)&&(~Timer_Flag)&&((XBYTE[STROBE_REG]&0x80)==0x80)&&(P0_5));
                if(P0_5==0)
                    TalkBackFlag = 1;

                while((~KEY_Pair)&&(~Timer_Flag)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                TR0 = 0;
                if((XBYTE[STROBE_REG]&0x80)==0x80)
                {
                    if(KEY_Pair)
                        break;
                    else
                    {
                        StrobeCmd(CMD_STBY);                        
												Search_Channel();
                        SetCH(Hop_Tab[Link_index]);
                        StrobeCmd(CMD_RX);
                        TIMEBASE = 1270;
                        InitTimer0();
                        while((~KEY_Pair)&&(~Timer_Flag)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                        TR0 = 0;
                        if((XBYTE[STROBE_REG]&0x80)==0x80)
                        {
                            if(KEY_Pair)
                                break;
                            else
                            {
                                StrobeCmd(CMD_STBY);
																Search_Channel();
                                SetCH(Hop_Tab[Link_index]);
                                StrobeCmd(CMD_RX);
                                TIMEBASE = 1270;
                                InitTimer0();
                                while((~KEY_Pair)&&(~Timer_Flag)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                                TR0 = 0;

                                if((XBYTE[STROBE_REG]&0x80)==0x80)
                                {
                                    if(KEY_Pair)
                                        break;
                                    else
                                    {
                                        StrobeCmd(CMD_STBY);
                                        TIMEBASE = 1600;
                                        InitTimer0();
                                        Link_Quality++;

                                        if(Link_Quality>2)
                                            A8101_WriteReg(CODEC_EFFCTL,0x06);
                                    }
                                }
                                else
                                {
                                    if(Link_Quality != 0)
                                    {																				
                                        A8101_WriteReg(CODEC_EFFCTL,0x02);
                                        Link_Quality = 0;
                                    }

                                    if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                                        TIMEBASE = 4350;
                                    else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                                        TIMEBASE = 3080;
                                    else
                                        TIMEBASE = 1800;

                                    InitTimer0();

                                    XBYTE[FIFO1_REG] = 0x04;
                                    StrobeCmd(CMD_TX);
                                    XBYTE[TXDATA_REG] = ((((Uint8)TalkBackFlag)<<1)|ACK_Flag);
                                    RSSI = XBYTE[RSSI_REG];
                                    Temperature = XBYTE[RXDATA_REG+69];
                                    MAX_VOL = XBYTE[RXDATA_REG+70];

                                    while(BufEmpty&&(~KEY_Pair));

                                    for(i=0;i<64;i++)
                                        CODECBUF[~BufGroup][i] = XBYTE[RXDATA_REG+i];
																		
																		if(CH_STATE[0]!= (XBYTE[RXDATA_REG+64]&0x0F))
																				ACK_Flag = 1;
																		else if(CH_STATE[1]!= (XBYTE[RXDATA_REG+65]))
																				ACK_Flag = 1;
																		else if(CH_STATE[2]!= (XBYTE[RXDATA_REG+66]))
																				ACK_Flag = 1;
																		else if(CH_STATE[3]!= (XBYTE[RXDATA_REG+67]))
																				ACK_Flag = 1;
																		else if(CH_STATE[4]!= (XBYTE[RXDATA_REG+68]))
																				ACK_Flag = 1;
																		else
																				ACK_Flag = 0;
																		
																		if(ACK_Flag)
																		{
																				CH_STATE[0] = (XBYTE[RXDATA_REG+64]&0x0F);
																				CH_STATE[1] = (XBYTE[RXDATA_REG+65]);
																				CH_STATE[2] = (XBYTE[RXDATA_REG+66]);
																				CH_STATE[3] = (XBYTE[RXDATA_REG+67]);
																				CH_STATE[4] = (XBYTE[RXDATA_REG+68]);
																				New_CH_STATE[0] = (XBYTE[RXDATA_REG+64]&0x0F);
																				New_CH_STATE[1] = XBYTE[RXDATA_REG+65];
																				New_CH_STATE[2] = XBYTE[RXDATA_REG+66];
																				New_CH_STATE[3] = XBYTE[RXDATA_REG+67];
																				New_CH_STATE[4] = XBYTE[RXDATA_REG+68];
																				
																				New_Channel_Table();
																		}
										
                                    DisplayBar();

                                    BufEmpty = 1;
                                }
                            }
                        }
                        else
                        {												
                            if(Link_Quality != 0)
                            {																
                                A8101_WriteReg(CODEC_EFFCTL,0x02);
                                Link_Quality = 0;
                            }

                            if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                                TIMEBASE = 4350;
                            else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                                TIMEBASE = 3080;
                            else
                                TIMEBASE = 1800;

                            InitTimer0();

                            XBYTE[FIFO1_REG] = 0x04;
                            StrobeCmd(CMD_TX);
                            XBYTE[TXDATA_REG] = ((((Uint8)TalkBackFlag)<<1)|ACK_Flag);
                            RSSI = XBYTE[RSSI_REG];
                            Temperature = XBYTE[RXDATA_REG+69];
                            MAX_VOL = XBYTE[RXDATA_REG+70];
                            while(BufEmpty&&(~KEY_Pair));

                            for(i=0;i<64;i++)
                                CODECBUF[~BufGroup][i] = XBYTE[RXDATA_REG+i];
														
														if(CH_STATE[0]!= (XBYTE[RXDATA_REG+64]&0x0F))
																ACK_Flag = 1;
														else if(CH_STATE[1]!= (XBYTE[RXDATA_REG+65]))
																ACK_Flag = 1;
														else if(CH_STATE[2]!= (XBYTE[RXDATA_REG+66]))
																ACK_Flag = 1;
														else if(CH_STATE[3]!= (XBYTE[RXDATA_REG+67]))
																ACK_Flag = 1;
														else if(CH_STATE[4]!= (XBYTE[RXDATA_REG+68]))
																ACK_Flag = 1;
														else
																ACK_Flag = 0;
														
														if(ACK_Flag)
														{
																CH_STATE[0] = (XBYTE[RXDATA_REG+64]&0x0F);
																CH_STATE[1] = (XBYTE[RXDATA_REG+65]);
																CH_STATE[2] = (XBYTE[RXDATA_REG+66]);
																CH_STATE[3] = (XBYTE[RXDATA_REG+67]);
																CH_STATE[4] = (XBYTE[RXDATA_REG+68]);
																New_CH_STATE[0] = (XBYTE[RXDATA_REG+64]&0x0F);
																New_CH_STATE[1] = XBYTE[RXDATA_REG+65];
																New_CH_STATE[2] = XBYTE[RXDATA_REG+66];
																New_CH_STATE[3] = XBYTE[RXDATA_REG+67];
																New_CH_STATE[4] = XBYTE[RXDATA_REG+68];
																
																New_Channel_Table();
														}
										
                            DisplayBar();

                            BufEmpty = 1;
														
														Search_Channel();
                        }
                    }
                }
                else
                {												
                    if(Link_Quality != 0)
                    {												
                        A8101_WriteReg(CODEC_EFFCTL,0x02);
                        Link_Quality = 0;
                    }																		
																
                    if((XBYTE[RXDATA_REG+64]&0x30)==0x10)
                        TIMEBASE = 4350;
                    else if((XBYTE[RXDATA_REG+64]&0x30)==0x20)
                        TIMEBASE = 3080;
                    else
                        TIMEBASE = 1800;

                    InitTimer0();

                    XBYTE[FIFO1_REG] = 0x04;
                    StrobeCmd(CMD_TX);
                    XBYTE[TXDATA_REG] = ((((Uint8)TalkBackFlag)<<1)|ACK_Flag);
                    RSSI = XBYTE[RSSI_REG];
                    Temperature = XBYTE[RXDATA_REG+69];
                    MAX_VOL = XBYTE[RXDATA_REG+70];

                    while(BufEmpty&&(~KEY_Pair));

                    for(i=0;i<64;i++)
                        CODECBUF[~BufGroup][i] = XBYTE[RXDATA_REG+i];
										
										if(CH_STATE[0]!= (XBYTE[RXDATA_REG+64]&0x0F))
												ACK_Flag = 1;
										else if(CH_STATE[1]!= (XBYTE[RXDATA_REG+65]))
												ACK_Flag = 1;
										else if(CH_STATE[2]!= (XBYTE[RXDATA_REG+66]))
												ACK_Flag = 1;
										else if(CH_STATE[3]!= (XBYTE[RXDATA_REG+67]))
												ACK_Flag = 1;
										else if(CH_STATE[4]!= (XBYTE[RXDATA_REG+68]))
												ACK_Flag = 1;
										else
												ACK_Flag = 0;
										
										if(ACK_Flag)
										{
												CH_STATE[0] = (XBYTE[RXDATA_REG+64]&0x0F);
												CH_STATE[1] = (XBYTE[RXDATA_REG+65]);
												CH_STATE[2] = (XBYTE[RXDATA_REG+66]);
												CH_STATE[3] = (XBYTE[RXDATA_REG+67]);
												CH_STATE[4] = (XBYTE[RXDATA_REG+68]);
												New_CH_STATE[0] = (XBYTE[RXDATA_REG+64]&0x0F);
												New_CH_STATE[1] = XBYTE[RXDATA_REG+65];
												New_CH_STATE[2] = XBYTE[RXDATA_REG+66];
												New_CH_STATE[3] = XBYTE[RXDATA_REG+67];
												New_CH_STATE[4] = XBYTE[RXDATA_REG+68];
												
												New_Channel_Table();
										}
										
                    DisplayBar();
                    BufEmpty = 1;

                    Search_Channel();
										Search_Channel();
                }

                if(KEY_Pair||(Link_Quality>200)||TalkBackFlag)
                {
                    if((XBYTE[RST_REG]&0x03)==0x01)
                        StrobeCmd(CMD_STBY);
                    while((XBYTE[STROBE_REG]&0x80)==0x80);
                    A8101_WriteReg(CODEC_ANACTL,0x00);
                    A8101_WriteReg(CODEC_CODECTL,0x00);
                    P1_2 = 0;
                    break;
                }
            }
        }

        if(KEY_Pair||(Link_Quality>200)||TIMEOUT)
        {
            if((XBYTE[RST_REG]&0x03)==0x01)
                StrobeCmd(CMD_STBY);

            while((XBYTE[STROBE_REG]&0x80)==0x80);
            A8101_WriteReg(CODEC_ANACTL,0x00);
            A8101_WriteReg(CODEC_CODECTL,0x00);
            P1_2 = 0;
        }

        if(Link_Quality>200)
            LINK_FAIL = 1;

        if(TalkBackFlag)
        {  
            P1_2 = 1;
            P1 &= 0x07;
            BufGroup = 0;
            BufIndex = 0;
            DataTxFlag = 0;
            Link_Quality = 0;
            Update_Flag = 0;
            ACK_Flag = 0;
            Link_index = 0;
            TalkBackFlag = 0;
            Channel_number = 36;
            CH_STATE[0] = 0x0F;
            for(i=1;i<5;i++)
                CH_STATE[i] = 0xFF;
            New_CH_STATE[0] = 0x0F;
            for(i=1;i<5;i++)
                New_CH_STATE[i] = 0xFF;
            MAX_VOL = 0;
            TIMEBASE = 240;
            A8101_WriteReg(CODE1_REG,0x1C);
            A8101_WriteReg(CODE2_REG,0x8E);     //0x8E  enable CRC filtering
            A8101_WriteReg(FCR_REG,0x00);       //resend disable
            A8101_WriteReg(GIO1_REG,0x00);
            A8101_WriteReg(GIO2_REG,0x10);
            A8101_WriteReg(CKO_REG,0x02);

            A8101_WriteReg(CODEC_CODECTL,0x00);
            A8101_WriteReg(CODEC_SRSEL,0x08);
            A8101_WriteReg(CODEC_AMP,0x5F);
            A8101_WriteReg(CODEC_ANACTL,0x0F);
            A8101_WriteReg(CODEC_TESTMODE,0x08);
            EIE |= 0x04;

            ResetCmd(FIFODATA_RST);
            A8101_WriteReg(CODEC_CODECTL,0xB0);
            Delay1ms(500);
            A8101_WriteReg(CODEC_OSCAL2,0x1A);
            DataTxFlag = 0;

            while(1)
            {
                XBYTE[FIFO1_REG] = 0x48;
                if(Link_index>35)
                    Link_index = 0;
                SetCH(Hop_Tab[Link_index]);
                MeasureExtADC();
                while((~KEY_Pair)&&(~DataTxFlag));
                while((~KEY_Pair)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                if(~KEY_Pair)
                {
                    for(i=0;i<64;i++)
                        XBYTE[TXDATA_REG+i] = CODECBUF[~BufGroup][i];
                    StrobeCmd(CMD_TX);
                    XBYTE[TXDATA_REG+64] = (0x10|New_CH_STATE[0]|(((Uint8)Update_Flag)<<7));
                    XBYTE[TXDATA_REG+65] = New_CH_STATE[1];
                    XBYTE[TXDATA_REG+66] = New_CH_STATE[2];
                    XBYTE[TXDATA_REG+67] = New_CH_STATE[3];
                    XBYTE[TXDATA_REG+68] = New_CH_STATE[4];
                    XBYTE[TXDATA_REG+69] = Temperature;
                    XBYTE[TXDATA_REG+70] = MAX_VOL;
                    XBYTE[TXDATA_REG+71] = 0x00;
                    XBYTE[TXDATA_REG+72] = 0x00;
                    MAX_VOL = 0;
                    DataTxFlag = 0;
                    while(((XBYTE[STROBE_REG]&0x80)==0x80));
                    Update_Flag = 0;
                    XBYTE[FIFO1_REG] = 0x04;
                    StrobeCmd(CMD_RX);
                    InitTimer0();
                    while((Timer_Flag==0)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                    TR0 = 0;
                    if((XBYTE[STROBE_REG]&0x80)==0x80)
                    {
                        StrobeCmd(CMD_STBY);
                        // close channel
                        Link_index++;
                        if(Link_index>35)
                            Link_index = 0;
                        SetCH(Hop_Tab[Link_index]);
                        XBYTE[FIFO1_REG] = 0x48;
                        StrobeCmd(CMD_TX);
                        XBYTE[TXDATA_REG+64] = (0x20|New_CH_STATE[0]|(((Uint8)Update_Flag)<<7));
                        XBYTE[TXDATA_REG+65] = New_CH_STATE[1];
                        XBYTE[TXDATA_REG+66] = New_CH_STATE[2];
                        XBYTE[TXDATA_REG+67] = New_CH_STATE[3];
                        XBYTE[TXDATA_REG+68] = New_CH_STATE[4];
                        while(((XBYTE[STROBE_REG]&0x80)==0x80));
                        Update_Flag = 0;
                        XBYTE[FIFO1_REG] = 0x04;
                        StrobeCmd(CMD_RX);
                        InitTimer0();
                        while((Timer_Flag==0)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                        TR0 = 0;
                        if((XBYTE[STROBE_REG]&0x80)==0x80)
                        {
                            StrobeCmd(CMD_STBY);

                            // close channel
                            Link_index++;
                            if(Link_index>35)
                                Link_index = 0;

                            SetCH(Hop_Tab[Link_index]);
                            XBYTE[FIFO1_REG] = 0x48;
                            StrobeCmd(CMD_TX);
                            XBYTE[TXDATA_REG+64] = (0x30|New_CH_STATE[0]|(((Uint8)Update_Flag)<<7));
                            XBYTE[TXDATA_REG+65] = New_CH_STATE[1];
                            XBYTE[TXDATA_REG+66] = New_CH_STATE[2];
                            XBYTE[TXDATA_REG+67] = New_CH_STATE[3];
                            XBYTE[TXDATA_REG+68] = New_CH_STATE[4];
                            while(((XBYTE[STROBE_REG]&0x80)==0x80));
                            Update_Flag = 0;

                            XBYTE[FIFO1_REG] = 0x04;
                            StrobeCmd(CMD_RX);
                            InitTimer0();
                            while((Timer_Flag==0)&&((XBYTE[STROBE_REG]&0x80)==0x80));
                            TR0 = 0;
                            if((XBYTE[STROBE_REG]&0x80)==0x80)
                            {
                                StrobeCmd(CMD_STBY);
                                // close channel
                                ACK_Flag = 0;
                                Link_Quality++;
                            }
                            else
                            {
                                Link_Quality = 0;
                                RSSI = XBYTE[RSSI_REG];
                                ACK_Flag = XBYTE[RXDATA_REG]&0x01;
                            }
                        }
                        else
                        {
                            RSSI = XBYTE[RSSI_REG];
                            ACK_Flag = XBYTE[RXDATA_REG]&0x01;
                            Link_index++;
                            if(Link_index>35)
                                Link_index = 0;
                            Link_Quality = 0;
                        }
                    }
                    else
                    {
                        RSSI = XBYTE[RSSI_REG];
                        ACK_Flag = XBYTE[RXDATA_REG]&0x01;
                        n = 1;
                        do{
                            Link_index++;
                            if(Link_index>35)
                                Link_index = 0;
                        }while(n--);
                        Link_Quality = 0;
                    }
                    Link_index++;
                }

                if(P0_5)
                {
                    if((XBYTE[RST_REG]&0x03)==0x01)
                        StrobeCmd(CMD_STBY);

                    while((XBYTE[STROBE_REG]&0x80)==0x80);
                    A8101_WriteReg(CODEC_ANACTL,0x00);
                    A8101_WriteReg(CODEC_CODECTL,0x00);
                    P1_2 = 0;
                    break;
                }
            }
            LINK_FAIL = 1;
        }
    }
#endif
}